-------------------------------------------------------------------------------
-- File name : decode5x32.vhd
-- Title     : 5-bit to 32-bit decoder
-- project   : ECE 485
-- Library   : single-cycle processor
-- Author(s) : James E. Stine, Jr.
-- Purpose   : definition of single-cycle processor
-- notes :   

-- Copyright Illinois Institute of Technology
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity decode5x32 is
  port (Sel : in  std_logic_vector(4 downto 0);
        Clk : in  std_logic;
        Q   : out std_logic_vector(31 downto 0));
end decode5x32;

architecture structure of decode5x32 is
begin
  
  Q(31) <= Clk and Sel(4) and Sel(3) and Sel(2) and Sel(1) and Sel(0);
  Q(30) <= Clk and Sel(4) and Sel(3) and Sel(2) and Sel(1) and not Sel(0);
  Q(29) <= Clk and Sel(4) and Sel(3) and Sel(2) and not Sel(1) and Sel(0);
  Q(28) <= Clk and Sel(4) and Sel(3) and Sel(2) and not Sel(1) and not Sel(0);
  Q(27) <= Clk and Sel(4) and Sel(3) and not Sel(2) and Sel(1) and Sel(0);
  Q(26) <= Clk and Sel(4) and Sel(3) and not Sel(2) and Sel(1) and not Sel(0);
  Q(25) <= Clk and Sel(4) and Sel(3) and not Sel(2) and not Sel(1) and Sel(0);
  Q(24) <= Clk and Sel(4) and Sel(3) and not Sel(2) and not Sel(1) and not Sel(0);
  Q(23) <= Clk and Sel(4) and not Sel(3) and Sel(2) and Sel(1) and Sel(0);
  Q(22) <= Clk and Sel(4) and not Sel(3) and Sel(2) and Sel(1) and not Sel(0);
  Q(21) <= Clk and Sel(4) and not Sel(3) and Sel(2) and not Sel(1) and Sel(0);
  Q(20) <= Clk and Sel(4) and not Sel(3) and Sel(2) and not Sel(1) and not Sel(0);
  Q(19) <= Clk and Sel(4) and not Sel(3) and not Sel(2) and Sel(1) and Sel(0);
  Q(18) <= Clk and Sel(4) and not Sel(3) and not Sel(2) and Sel(1) and not Sel(0);
  Q(17) <= Clk and Sel(4) and not Sel(3) and not Sel(2) and not Sel(1) and Sel(0);
  Q(16) <= Clk and Sel(4) and not Sel(3) and not Sel(2) and not Sel(1) and not Sel(0);
  Q(15) <= Clk and not Sel(4) and Sel(3) and Sel(2) and Sel(1) and Sel(0);
  Q(14) <= Clk and not Sel(4) and Sel(3) and Sel(2) and Sel(1) and not Sel(0);
  Q(13) <= Clk and not Sel(4) and Sel(3) and Sel(2) and not Sel(1) and Sel(0);
  Q(12) <= Clk and not Sel(4) and Sel(3) and Sel(2) and not Sel(1) and not Sel(0);
  Q(11) <= Clk and not Sel(4) and Sel(3) and not Sel(2) and Sel(1) and Sel(0);
  Q(10) <= Clk and not Sel(4) and Sel(3) and not Sel(2) and Sel(1) and not Sel(0);
  Q(9) <= Clk and not Sel(4) and Sel(3) and not Sel(2) and not Sel(1) and Sel(0);
  Q(8) <= Clk and not Sel(4) and Sel(3) and not Sel(2) and not Sel(1) and not Sel(0);
  Q(7) <= Clk and not Sel(4) and not Sel(3) and Sel(2) and Sel(1) and Sel(0);
  Q(6) <= Clk and not Sel(4) and not Sel(3) and Sel(2) and Sel(1) and not Sel(0);
  Q(5) <= Clk and not Sel(4) and not Sel(3) and Sel(2) and not Sel(1) and Sel(0);
  Q(4) <= Clk and not Sel(4) and not Sel(3) and Sel(2) and not Sel(1) and not Sel(0);
  Q(3) <= Clk and not Sel(4) and not Sel(3) and not Sel(2) and Sel(1) and Sel(0);
  Q(2) <= Clk and not Sel(4) and not Sel(3) and not Sel(2) and Sel(1) and not Sel(0);
  Q(1) <= Clk and not Sel(4) and not Sel(3) and not Sel(2) and not Sel(1) and Sel(0);
  Q(0) <= Clk and not Sel(4) and not Sel(3) and not Sel(2) and not Sel(1) and not Sel(0);

end structure;
