-------------------------------------------------------------------------------
-- File name : alucontrol.vhdl
-- Title     : ALU control 
-- project   : ECE 485
-- Library   : single-cycle processor
-- Author(s) : James E. Stine, Jr.
-- Purpose   : definition of single-cycle processor
-- notes     : see alucontrol.in (espresso)

-- Copyright Illinois Institute of Technology
-------------------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

entity ALUcontrol is
  port (ALUop     : in std_logic_vector(1 downto 0);
        funct     : in std_logic_vector(5 downto 0);
        operation : out std_logic_vector(2 downto 0));
end ALUcontrol;

architecture structure of ALUcontrol is
begin

  operation(2) <= ALUop(0) or (ALUop(1) and funct(1));
  operation(1) <= (not ALUop(1)) or (not funct(2)) or ALUop(0);
  operation(0) <= ALUop(1) and (funct(3) or funct(0));
                  
  
end structure;
