-------------------------------------------------------------------------------
-- File name : register9.vhdl
-- Title     : 9-bit register
-- project   : ECE 485
-- Library   : single-cycle processor
-- Author(s) : James E. Stine, Jr.
-- Purpose   : definition of single-cycle processor
-- notes :   

-- Copyright Illinois Institute of Technology
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity register9 is
    port (d   :   in std_logic_vector(8 downto 0);
          clk :   in std_logic;
          reset : in std_logic;
          set :   in std_logic;
          q   :   out std_logic_vector(8 downto 0));
end register9;

architecture struct of register9 is

  component dff_sr 
    port (d     : in  std_logic;
          clk   : in  std_logic;
          reset : in  std_logic;
          set   : in  std_logic;
          q     : out std_logic);
  end component;
    
begin

  ff0 : dff_sr port map(d(0), clk, reset, set, q(0));
  ff1 : dff_sr port map(d(1), clk, reset, set, q(1));
  ff2 : dff_sr port map(d(2), clk, reset, set, q(2));
  ff3 : dff_sr port map(d(3), clk, reset, set, q(3));
  ff4 : dff_sr port map(d(4), clk, reset, set, q(4));
  ff5 : dff_sr port map(d(5), clk, reset, set, q(5));
  ff6 : dff_sr port map(d(6), clk, reset, set, q(6));
  ff7 : dff_sr port map(d(7), clk, reset, set, q(7));
  ff8 : dff_sr port map(d(8), clk, reset, set, q(8));

end struct;
