-------------------------------------------------------------------------------
-- File name : testbench.vhd
-- Title     : testbench
-- project   : ECE 485
-- Library   : single-cycle processor
-- Author(s) : James E. Stine, Jr.
-- Purpose   : definition of single-cycle processor
-- notes :   

-- Copyright Illinois Institute of Technology
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity toplevel is
  
end toplevel;

architecture struct of toplevel is

  component mipssc 
    port (clk            : in  std_logic;
          reset          : in  std_logic;
          instr          : in  std_logic_vector (31 downto 0);
          data_read      : in  std_logic_vector (31 downto 0);
          ack            : in  std_logic;
          ins_addr       : out std_logic_vector (8 downto 0);
          data_addr      : out std_logic_vector (8 downto 0);
          mem_write_data : out std_logic_vector (31 downto 0);
          stb            : out std_logic;
          we             : out std_logic);
  end component;

  component ins_mem512 
    port(adr     : in  std_logic_vector(8 downto 0);
         memdata : out std_logic_vector(31 downto 0));
  end component;

  component memwb
    port (ack_o : out std_logic;
          adr_i : in  std_logic_vector(  8 downto 0 );
          clk_i : in  std_logic;
          dat_i : in  std_logic_vector( 31 downto 0 );
          dat_o : out std_logic_vector( 31 downto 0 );
          stb_i : in  std_logic;
          we_i  : in  std_logic);
  end component;

  signal instr, data_read, mem_write_data  : std_logic_vector(31 downto 0);
  signal ins_addr, data_addr : std_logic_vector(8 downto 0);
  signal clk, reset, ack, stb, we : std_logic;
  
begin  

  dut : mipssc port map (clk, reset, instr, data_read, ack, ins_addr,
                         data_addr, mem_write_data, stb, we);
  pm1 : ins_mem512 port map(ins_addr, instr);
  dm1 : memwb port map(ack, data_addr, clk, mem_write_data, data_read,
                       stb, we);       

      process begin
                clk<='0';
                wait for 5 ns;
                clk<='1';
                wait for 5 ns;
      end process;

      process begin
                reset <= '0';
                wait for 10 ns;
                reset <= '1';
                wait for 200 ns;
      end process;

end struct;
